"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DefaultCacheStore = void 0;
class DefaultCacheStore {
    constructor() {
        this.store =
            typeof window !== 'undefined'
                ? window.localStorage
                : stubbedLocalStorage;
    }
    save(storeKey, data) {
        var _a;
        (_a = this.store) === null || _a === void 0 ? void 0 : _a.setItem(storeKey, JSON.stringify(data));
    }
    load(storeKey) {
        return new Promise((resolve) => {
            var _a;
            const item = (_a = this.store) === null || _a === void 0 ? void 0 : _a.getItem(storeKey);
            resolve(item ? JSON.parse(item) : null);
        });
    }
    remove(storeKey) {
        var _a;
        (_a = this.store) === null || _a === void 0 ? void 0 : _a.removeItem(storeKey);
    }
}
exports.DefaultCacheStore = DefaultCacheStore;
const stubbedLocalStorage = {
    getItem: () => null,
    setItem: () => undefined,
    removeItem: () => undefined,
    clear: () => undefined,
    key: () => null,
    length: 0,
};
exports.default = DefaultCacheStore;
//# sourceMappingURL=DefaultCacheStore.js.map