"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DVCRequestEvent = void 0;
const utils_1 = require("./utils");
const EventQueue_1 = require("./EventQueue");
class DVCRequestEvent {
    constructor(event, user_id, featureVars) {
        const { type, target, date, value, metaData } = event;
        (0, utils_1.checkParamDefined)('type', type);
        const isCustomEvent = !(type in EventQueue_1.EventTypes);
        this.type = isCustomEvent ? 'customEvent' : type;
        this.customType = isCustomEvent ? type : undefined;
        this.target = target;
        this.user_id = user_id;
        this.clientDate = date || Date.now();
        this.value = value;
        this.featureVars = featureVars || {};
        this.metaData = metaData;
    }
}
exports.DVCRequestEvent = DVCRequestEvent;
//# sourceMappingURL=RequestEvent.js.map